{-# LANGUAGE BangPatterns #-}

import Data.List
import Control.Parallel
import Control.Parallel.Strategies

fib 0 = 1
fib 1 = 1
fib n = fib (n-1) + fib (n-2)

main =
  let xs = [ fib (5 + n `mod` 10) | n <- [0..100000] ]
             `using` parListWHNF
   in print (sum xs)

parListWHNF :: Strategy [a]
parListWHNF xs = go xs `pseq` return xs
  where
 -- go :: [a] -> [a]
    go []     = []
    go (y:ys) = y `par` go ys

